import { defineAliasedType, assertNodeType, assertOneOf, assertValueType } from "./utils.js";
import { PLACEHOLDERS } from "./placeholders.js";
const defineType = defineAliasedType("Miscellaneous");
{
  defineType("Noop", {
    visitor: []
  });
}
defineType("Placeholder", {
  visitor: [],
  builder: ["expectedNode", "name"],
  fields: {
    name: {
      validate: assertNodeType("Identifier")
    },
    expectedNode: {
      validate: assertOneOf(...PLACEHOLDERS)
    }
  }
});
defineType("V8IntrinsicIdentifier", {
  builder: ["name"],
  fields: {
    name: {
      validate: assertValueType("string")
    }
  }
});

//# sourceMappingURL=misc.js.map
